/*
 * Copyright (c) 2018 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef IDLC_CS_GEN_CS_LIB_GEN_H_
#define IDLC_CS_GEN_CS_LIB_GEN_H_

#include <memory>
#include <string>

#include "idlc/cs_gen/cs_gen_base.h"

namespace tidl {

class CsLibGen : public CsGeneratorBase {
 public:
  explicit CsLibGen(std::shared_ptr<Document> doc);
  virtual ~CsLibGen() = default;

  void OnInitGen(std::ofstream& stream) override;
  void OnFiniGen(std::ofstream& stream) override;

 private:
  void GenInterop(std::ofstream& stream);
  void GenRpcPort(std::ofstream& stream);
};

}  // namespace tidl

#endif  // IDLC_CS_GEN_CS_LIB_GEN_H_
