/*
 * Copyright (c) 2017 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <utility>

#include "idlc/element.h"
#include "idlc/structure.h"
#include "idlc/block.h"

namespace tidl {

Structure::Structure(std::string id, Elements* elms, std::string comments,
                     unsigned line)
    : Block::Block(std::move(id), Block::TYPE_STRUCTURE,
                   std::move(comments), line), elms_(elms) {}

const Elements& Structure::GetElements() const {
  return *elms_;
}

}  // namespace tidl
